#!/usr/bin/python3
#
# Todo 
#
#	time since last detection
#
#	sensor-crossing. SxE
#	>> patch-crossing? PxE
#
#	dont cutOff first trackEvent from plateau to end
#
#	print more info: 
#		nLines before coolOff
#		nLines after coolOff
#		nLines after cutOff (total nDel lines)
#
import sys, os

cutOff=True

LEN_TIMESTAMP=len("1602626336")
COL_TIMESTAMP=0
COL_X=6
COL_Y=COL_X+1
COL_TAG=COL_Y+1
DELIM=","

OUT_COL_X=5
OUT_COL_Y=OUT_COL_X+1
OUT_COL_TAG=OUT_COL_Y+1

def squash(data):

	print("squash plateaus")

	coolOff = 2
	recent = []
	filtered = []
	for line in data:
		if line[0] == '#':
			if line.startswith("#timestamp"):
				HEADER = line
				filtered += HEADER
			continue

		l = line.split(DELIM)
		timestamp = int(l[COL_TIMESTAMP])
		tag = l[ COL_TAG ]
		x = l[ COL_X ]
		y = l[ COL_Y ]

		tagFound = False
		i=0
		while i < len(recent):
			
			# print(i,":",recent[i])
			samePos=(recent[i][OUT_COL_X] == x and recent[i][OUT_COL_Y] == y)
			recentBeetle=recent[i][OUT_COL_TAG] == tag
			fastBeetle = not samePos and recentBeetle
			ago = timestamp - recent[i][1]

			if ago > coolOff or fastBeetle:
				
				## add new squashed / trackevent
				filtered.append(DELIM.join(map(str,recent[i])))

				del recent[i]	# del old
				continue		# dont incr idx!

			if recentBeetle:
				
				## update
				tagFound = True
				dur = timestamp-recent[i][0]
				recent[i][1] = timestamp
				recent[i][2] = dur

			i +=1

		if not tagFound:

			## add recent
			recent.append([timestamp,timestamp,0]+l[4:]) #omit ts,ms,date,time

	## cutOff
	ncut = 0
	for r in recent:
		if cutOff:
			r[1] = r[0]
			ncut += r[2]
			r[2] = 0
		filtered.append(DELIM.join(map(str,r)))

	if cutOff:
		print(f"cutOff {ncut} lines")

	return filtered


def write(outFile, data):

	print(f"writing to {outFile}")
	with open(outFile, "w") as f:
		f.writelines(data)

	# cmd_compress=f"tar -zcvf {outFile}.tgz {outFile}" # ">/dev/null 2>/dev/null"
	# os.system(cmd_compress)

def main(filename):

	with open(filename) as f:
		data = f.readlines()

	print(len(data))
	data = squash( data )
	print(len(data))

	write(filename + "-filtered", data)

if __name__ == "__main__" :

	# main("ecolux-data-20200915-20200916")
	main("test")
	exit()
	if len(sys.argv) == 1:
		this = os.path.basename(__file__)
		
		sys.exit(	f'Usage:	{this} dataFile\n\n'
					f'	Squash plateaus (start/end/dur)\n'
					f'	CutOff tags at end. (eg tag lying on sensor)'
					f'	Time since last detection\n'
					f'	Sensor Cross Event?\n'
					f'	Patch Cross Event\n'	)

	main(sys.argv[1])
